package ru.landgrafhomyak.serdha.api.v0.ddl.table

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseTypesProvider
import ru.landgrafhomyak.serdha.api.v0.ddl.types.RowId

public interface CreateTableScope<TableUserExtension : Any> {
	public val expressionBuilder: Expression.Builder<TableUserExtension>

	public val types: DatabaseTypesProvider

	public fun <RT, DT : DatabaseType<RT>> column(name: String, type: DT): Column<RT, DT, TableUserExtension>

	public fun index(name: String, vararg columns: Column<*, *, TableUserExtension>): Index<TableUserExtension>

	public fun uniqueIndex(name: String, distinctNulls: Boolean, vararg columns: Column<*, *, TableUserExtension>): UniqueIndex<TableUserExtension>
	public fun checkConstraint(name: String, constraint: Expression<Boolean, DatabaseType.BOOLEAN, TableUserExtension>): CheckConstraint<TableUserExtension>
	public fun <RT : Any, DT : DatabaseType<RT>> defaultValue(c: Column<RT, DT, TableUserExtension>, expr: Expression<RT, DT, TableUserExtension>): DefaultConstraint<RT, DT, TableUserExtension>

	@Suppress("PropertyName")
	public val rowId_column: Column<RowId<TableUserExtension>, DatabaseType<RowId<TableUserExtension>>, TableUserExtension>

	@Suppress("PropertyName")
	public val rowId_uniqueConstraint: UniqueIndex<TableUserExtension>

	public fun <TargetTableUserWrapper : Any> selfRowReference(
		onDelete: ForeignRowReference.OnDeleteAction,
		toColumn: Column<RowId<TargetTableUserWrapper>, DatabaseType.ROW_ID<TargetTableUserWrapper>, TargetTableUserWrapper>,
	): ForeignRowReference<TableUserExtension, TableUserExtension>

	public fun <TargetTableUserWrapper : Any> foreignRowReference(
		fromColumn: Column<RowId<TargetTableUserWrapper>, DatabaseType.ROW_ID<TargetTableUserWrapper>, TableUserExtension>,
		toTable: Table<TargetTableUserWrapper, *>,
		toColumn: Column<RowId<TargetTableUserWrapper>, DatabaseType.ROW_ID<TargetTableUserWrapper>, TargetTableUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction,
	): ForeignRowReference<TableUserExtension, TargetTableUserWrapper>
}