package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType

public interface CreateInsertQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CreateInsertOrCopyQueryScope<TargetTableUserExtension, QueryUserExtension> {
	public class DataParam<@Suppress("unused") QueryUserExtension : Any> private constructor()

	public val dataExpressionBuilder: Expression.Builder<DataParam<QueryUserExtension>>

	public fun <RT, DT : DatabaseType<RT>> dataParam(name: String, type: DT): InputParam<RT, DT, DataParam<QueryUserExtension>>

	public fun <RT, DT : DatabaseType<RT>> insertParam(
		column: Column<RT, DT, TargetTableUserExtension>,
		paramName: String = column.name,
	): InputParam<RT, DT, DataParam<QueryUserExtension>>

	public fun <RuntimeType, DT : DatabaseType<RuntimeType>> insert(column: Column<RuntimeType, DT, TargetTableUserExtension>, expression: Expression<RuntimeType, DT, DataParam<QueryUserExtension>>)
}