package ru.landgrafhomyak.serdha.api.v0.dml

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.table.Column
import ru.landgrafhomyak.serdha.api.v0.ddl.types.DatabaseType

public interface CreateUpdateQueryScope<TargetTableUserExtension : Any, QueryUserExtension : Any> : _CommonCreateQueryScope<QueryUserExtension> {
	public val targetTable: SelectedTable<TargetTableUserExtension, QueryUserExtension>

	public fun <RuntimeType, DT : DatabaseType<RuntimeType>> selectOldColumnValue(c: Column<RuntimeType, DT, TargetTableUserExtension>): Expression<RuntimeType, DT, QueryUserExtension>

	public fun <RuntimeType, DT : DatabaseType<RuntimeType>> updateColumn(c: Column<RuntimeType, DT, TargetTableUserExtension>, e: Expression<RuntimeType, DT, QueryUserExtension>)

	public fun where(expression: Expression<Boolean, DatabaseType.BOOLEAN, QueryUserExtension>)

	public fun limit(size: UInt)

	@Suppress("SpellCheckingInspection")
	public fun offsetedLimit(offset: ULong, size: UInt)

	public val returning: _CommonCreateQueryScope._ReturningClauseScope<QueryUserExtension>
}